clear all
close all
clc

% Podemos hacer una funcion que genere la matriz para n arbitrario. Sin
% embargo lo resolveremos para n = 10.

n = 10;

% Si sumamos la diagonal de n's a una matriz llena de 1s, obtenemos la
% matriz deseada. El vector b se obtiene utilizando ones.
A = ones(n) + n*eye(n);
b = ones(n, 1);

% Para comprobar que A es simetrica, veremos si A = A', utilizamos floor
% (funcion piso) para asegurarnos que el resultado es entero y se pueda
% comparar con 0 (En este caso se puede hacer simplemente con norm, en
% otros hay que ser un poco mas paranoicos.
if floor(norm(A - A')) == 0
    disp('La matriz es simetrica')
end

% Seguiremos el sabio consejo de la guia, y verificaremos si los valores
% propios son todos positivos.
if all(eig(A) > 0)
    disp('La matriz es definida positiva')
end

% Encontramos la factorizacion de cholesky, en este caso, R es triangular
% SUPERIOR. En la guia esta la factorizacion con triangular inferior (es
% correcto, pero el MATLAB calcula la superior). Acabo de ver que en estos
% MATLABs nuevos se puede hacer L = chol(A,'lower').
R = chol(A);

% Resolvemos el sistema de ecuaciones (para llegar a esto, es la misma idea
% que vimos con la factorizacion LU.
xchol = R\(R'\b);
x = A\b;

% Control de sanidad
norm(xchol - x)
