function[t1,t2,normadiferencia] = variossistemas
% funcion para observar importancia de re-uso de descomposicion LU

% Se crea una matriz tridiagonal.
A=create_trid(50,.5,1,1);

% Se estan creando Sistemas de ecuaciones con segundo miembro cada columna
% de B, es decir b1 = B(:, 1), b2 = B(:, 2), etc...
B = rand(50,100);

% tic inicia un contador interno en MATLAB que termina con la instruccion
% toc. Basicamente se esta midiendo el tiempo que tarda la instruccion
% entre tic y toc, es decir, cuanto demora A\B
tic
X = A\B;
t1 = toc;

% Se inicializa una matriz, que contendra las soluciones de cada sistema de
% ecuaciones.
Y = zeros(50,100);
tic
for i=1:100
    Y(:,i) = A\B(:,i);
end
t2 = toc;

% Se verifica que tengan las mismas soluciones.
normadiferencia = norm(X-Y,inf);

% El primer metodo es mas eficiente debido a que utiliza funciones internas
% de MATLAB que estan pre-compiladas. En el segundo caso, con el ciclo, el
% interprete tiene que seguir las instrucciones en tiempo de ejecucion, lo
% cual es menos eficiente. La implementacion interna del operador \ permite
% una mejor eficiencia con el primer metodo. Moraleja: Vectorizar es
% siempre mejor que utilizar ciclos.
end
